// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "scene/components/display/TiledSprite.hpp"
#include "games/tictactoe/TicTacToeLogic.hpp"

namespace Dawn {
  class TicTacToeTile : public SceneItemComponent {
    public:
      StateProperty<enum TicTacToeTileState> tileState;
      StateProperty<bool_t> hovered;
      uint8_t tile;

      TicTacToeTile(SceneItem *item);
      void onStart() override;
  };
}